require "import"
import "android.widget.*"
import "android.view.*"
import "android.os.Handler"
import "java.io.File"

-- مسار الملف
local filePath = "/storage/emulated/0/解说/Tools/ملاحظاتي/files/protect system and copyrights/system_name_myNote.lua"

-- واجهة التحميل
local loadingLayout = {
  LinearLayout;
  orientation = "vertical";
  layout_width = "match_parent";
  layout_height = "match_parent";
  gravity = "center";
  {
    ProgressBar;
    layout_width = "wrap_content";
    layout_height = "wrap_content";
  };
  {
    TextView;
    text = "جار التحميل...";
    layout_width = "wrap_content";
    layout_height = "wrap_content";
    textSize = 16;
    textColor = "#ffffff";
    layout_marginTop = "10dp";
  };
}

-- إظهار نافذة التحميل
local dlg = LuaDialog()
dlg.setTitle("جار التحميل")
dlg.setView(loadlayout(loadingLayout))
dlg.show()

-- دالة التحقق والتنفيذ
local function checkAndRun()
  local f = File(filePath)

  if f.exists() then
    -- محاولة تنفيذ الملف
    local success, err = pcall(function() dofile(filePath) end)

    if success then
      dlg.dismiss()
    else
      dlg.dismiss()
      local errorLayout = {
        LinearLayout;
        orientation = "vertical";
        layout_width = "match_parent";
        layout_height = "match_parent";
        gravity = "center";
        backgroundColor = "#000000";
        {
          TextView;
          text = "حدث خطأ أثناء تنفيذ الملف:\n" .. tostring(err);
          textSize = 16;
          textColor = "#ffffff";
          layout_margin = "20dp";
        };
        {
          Button;
          text = "حسناً";
          onClick = function(view)
            errorDlg.dismiss()
            if service.execute("Go back") then
              return true
            end
          end;
        };
      }

      errorDlg = LuaDialog()
      errorDlg.setTitle("خطأ في التنفيذ")
      errorDlg.setView(loadlayout(errorLayout))
      errorDlg.show()
    end
  else
    -- الملف غير موجود: عرض سوء الاستخدام
    dlg.dismiss()
    local errorLayout = {
      LinearLayout;
      orientation = "vertical";
      layout_width = "match_parent";
      layout_height = "match_parent";
      gravity = "center";
      backgroundColor = "#000000";
      {
        TextView;
        text = "تم العثور على سوء استخدام. قم بإعادة تسمية الأداة باسمها الأصلي: ملاحظاتي، وأعد المحاولة.";
        textSize = 16;
        textColor = "#ffffff";
        layout_margin = "20dp";
      };
      {
        Button;
        text = "حسناً";
        onClick = function(view)
          errorDlg.dismiss()
          if service.execute("Go back") then
            return true
          end
        end;
      };
    }

    errorDlg = LuaDialog()
    errorDlg.setTitle("خطأ")
    errorDlg.setView(loadlayout(errorLayout))
    errorDlg.show()
  end
end

-- تنفيذ الدالة بعد تأخير بسيط
local handler = Handler()
handler.postDelayed(
  Runnable { run = function() checkAndRun() end },
  600
)