layout = {
  RelativeLayout;
  layout_width = "match_parent";
  layout_height = "match_parent";
  backgroundColor = "#ffffff";

  {
    Button;
    id = "openNavButton";
    text = "Open Navigation Menu";
    layout_width = "match_parent";
    layout_height = "wrap_content";
    layout_alignParentTop = "true";
    textColor = "#ffffff";
    backgroundColor = "#009688";
    onClick = function()
      if openNavButton.text == "Open Navigation Menu" then
        browseButton.setVisibility(View.GONE)
        newNoteButton.setVisibility(View.GONE)
        notesList.setVisibility(View.GONE)
        settingsButton.setVisibility(View.VISIBLE)

        openNavButton.text = "Close Navigation Menu"
      else
        browseButton.setVisibility(View.VISIBLE)
        newNoteButton.setVisibility(View.VISIBLE)
        notesList.setVisibility(View.VISIBLE)
        settingsButton.setVisibility(View.GONE)

        openNavButton.text = "Open Navigation Menu"
      end
    end;
  };

  {
    TextView;
    id = "titleView";
    layout_width = "match_parent";
    layout_height = "wrap_content";
    text = T.my_notes;
    textSize = "24sp";
    textColor = "#000000";
    gravity = "center";
    padding = "16dp";
    layout_below = "openNavButton";
  };

  {
    Button;
    id = "browseButton";
    text = T.browse;
    layout_width = "match_parent";
    layout_height = "wrap_content";
    layout_below = "titleView";
    textColor = "#ffffff";
    backgroundColor = "#00796b";
  };

  {
    Button;
    id = "newNoteButton";
    text = T.new_note;
    layout_width = "match_parent";
    layout_height = "wrap_content";
    layout_alignParentBottom = "true";
    backgroundColor = "#1565c0";
    textColor = "#ffffff";
    textSize = "18sp";
  };

  {
    ListView;
    id = "notesList";
    layout_width = "match_parent";
    layout_height = "match_parent";
    layout_below = "browseButton";
    layout_above = "newNoteButton";
  };

  {
    Button;
    id = "settingsButton";
    text = "Settings";
    layout_width = "wrap_content";
    layout_height = "wrap_content";
    layout_centerInParent = "true";
    backgroundColor = "#9e9e9e";
    textColor = "#ffffff";
    visibility = "gone";
    onClick = function()
      dofile("/storage/emulated/0/解说/Tools/ملاحظاتي/files/Layout/Settings.lua")
    end;
  };
}

activity.setContentView(loadlayout(layout))
activity.setTitle(T.my_notes)
