function deleteNote(filePath)
  AlertDialog.Builder(activity)
    .setTitle(T.confirm_delete)
    .setMessage(T.delete_question)
    .setPositiveButton(T.delete, function()
      local f = File(filePath)
      if f.exists() then f.delete() end
      playDeleteSound()
      refreshNotes()
    end)
    .setNegativeButton(T.cancel, nil)
    .show()
end